;;; -*- Syntax: Ansi-Common-Lisp; Base: 10; Mode: lisp; Package: imho -*-
;;; $Id: csv-presentation.lisp,v 1.4 2003/03/26 19:52:16 adam Exp $
;;;
;;; Copyright (c) 1999 - 2003 onShore Development, Inc.
;;;
;;; See the file 'COPYING' in this directory for terms.

(in-package :imho)

;; escape any escape characters, then escape any quotes then wrap the lot up in quotes.
(defun csv-escape (string)
  (format nil "~C~A~C" #\"
	  (odcl:string-replace #\" "\""
	     (odcl:string-replace #\\ "\\" string)) #\"))

(define-presentation-method present  (object (type t)
                                            stream
				     (view csv-view)
				     &key acceptably for-context-type)
  (declare (ignore acceptably for-context-type))
  (with-output-to-string (outstream)
			 (present object type :stream outstream :view imho::+textual-view+)
			 (write-string (csv-escape (get-output-stream-string outstream)) stream)))

(define-presentation-method present  (object (type null)
                                            stream
				     (view csv-view)
				     &key acceptably for-context-type)
  (declare (ignore acceptably for-context-type))
  (with-output-to-string (outstream)
			 (present object type :stream outstream :view imho::+textual-view+)
			 (write-string (csv-escape (get-output-stream-string outstream)) stream)))

(define-presentation-method present  (object (type symbol)
                                            stream
				     (view csv-view)
				     &key acceptably for-context-type)
  (declare (ignore acceptably for-context-type))
  (with-output-to-string (outstream)
			 (present object type :stream outstream :view imho::+textual-view+)
			 (write-string (csv-escape (get-output-stream-string outstream)) stream)))

(define-presentation-method present  (object (type keyword)
                                            stream
				     (view csv-view)
				     &key acceptably for-context-type)
  (declare (ignore acceptably for-context-type))
  (write-string (csv-escape (symbol-name object)) stream))

(define-presentation-method present  (object (type complex)
                                            stream
				     (view csv-view)
				     &key acceptably for-context-type)
  (declare (ignore acceptably for-context-type))
  (with-output-to-string (outstream)
			 (present object type :stream outstream :view imho::+textual-view+)
			 (write-string (csv-escape (get-output-stream-string outstream)) stream)))

(define-presentation-method present  (object (type real)
                                            stream
				     (view csv-view)
				     &key acceptably for-context-type)
  (declare (ignore acceptably for-context-type))
  (with-output-to-string (outstream)
			 (present object type :stream outstream :view imho::+textual-view+)
			 (write-string (csv-escape (get-output-stream-string outstream)) stream)))

(define-presentation-method present  (object (type integer)
                                            stream
				     (view csv-view)
				     &key acceptably for-context-type)
  (declare (ignore acceptably for-context-type))
  (with-output-to-string (outstream)
			 (present object type :stream outstream :view imho::+textual-view+)
			 (write-string (csv-escape (get-output-stream-string outstream)) stream)))

(define-presentation-method present  (object (type string)
                                            stream
				     (view csv-view)
				     &key acceptably for-context-type)
  (declare (ignore acceptably for-context-type))
  (with-output-to-string (outstream)
			 (present object type :stream outstream :view imho::+textual-view+)
			 (write-string (csv-escape (get-output-stream-string outstream)) stream)))

